%global namedreltag .RELEASE
%global namedversion %{version}%{?namedreltag}
%global oname spring-batch
%global with_vpp 0
Name:          springframework-batch
Version:       2.1.9
Release:       3%{?dist}
Summary:       Tools for enterprise batch or bulk processing
License:       ASL 2.0
URL:           http://www.springsource.org/spring-batch
# lastest release require springframework >= 3.2.0.RELEASE
Source0:       https://github.com/spring-projects/%{oname}/archive/%{namedversion}.tar.gz
Patch0:        %{name}-2.1.9-core-add-missing-beans-method.patch
Patch1:        %{name}-2.1.9-core-StepScope.patch

BuildRequires: hibernate3
BuildRequires: hibernate3-entitymanager
BuildRequires: mvn(com.h2database:h2)
BuildRequires: mvn(com.thoughtworks.xstream:xstream)
BuildRequires: mvn(commons-collections:commons-collections)
BuildRequires: mvn(commons-dbcp:commons-dbcp)
BuildRequires: mvn(commons-io:commons-io)
BuildRequires: mvn(hsqldb:hsqldb:1)
BuildRequires: mvn(javax.mail:mail)
#BuildRequires: geronimo-jpa
BuildRequires: mvn(javax.persistence:persistence-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(net.sf.cglib:cglib)
BuildRequires: mvn(org.aspectj:aspectjweaver)
BuildRequires: mvn(org.easymock:easymock)
BuildRequires: mvn(org.eclipse.gemini.blueprint:gemini-blueprint-core)
BuildRequires: mvn(org.apache.felix:org.osgi.core)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:specs:pom:)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.codehaus.jettison:jettison)
BuildRequires: mvn(org.codehaus.woodstox:woodstox-core-asl)
BuildRequires: mvn(org.slf4j:slf4j-log4j12)
BuildRequires: mvn(org.springframework:spring-aop)
BuildRequires: mvn(org.springframework:spring-beans)
BuildRequires: mvn(org.springframework:spring-context)
BuildRequires: mvn(org.springframework:spring-context-support)
BuildRequires: mvn(org.springframework:spring-core)
BuildRequires: mvn(org.springframework:spring-jdbc)
BuildRequires: mvn(org.springframework:spring-jms)
BuildRequires: mvn(org.springframework:spring-orm)
BuildRequires: mvn(org.springframework:spring-oxm)
BuildRequires: mvn(org.springframework:spring-tx)
BuildRequires: mvn(org.springframework.ws:spring-ws-core)

# test deps
BuildRequires: mvn(org.apache.derby:derby)

BuildRequires: maven-local
BuildRequires: maven-plugin-bundle

%if %with_vpp
BuildRequires: maven-antrun-plugin
# antrun-plugin deps
# http://gil.fedorapeople.org/foundrylogic-vpp-2.2.1-1.fc19.src.rpm
BuildRequires: foundrylogic-vpp
%endif

BuildArch:     noarch

%description
Spring Batch provides tools for enterprise batch or bulk processing. It
can be used to wire up jobs, and track their execution, or simply as an
optimization for repetitive processing in a transactional environment.
Spring Batch is part of the Spring Portfolio.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{oname}-%{namedversion}
%patch0 -p0
# Remove problems with Java 8
# spring-batch-core/src/main/java/org/springframework/batch/core/scope/util/PlaceholderTargetSource.java:[163,40] reference to convertIfNecessary is ambiguous
# [ERROR] both method convertIfNecessary(java.lang.Object,java.lang.Class,org.springframework.core.MethodParameter)
# in <anonymous org.springframework.batch.core.scope.util.PlaceholderTargetSource$1> and
# method <T>convertIfNecessary(java.lang.Object,java.lang.Class<T>,java.lang.reflect.Field)
# in <anonymous org.springframework.batch.core.scope.util.PlaceholderTargetSource$1> match
%patch1 -p0
rm -r spring-batch-core/src/main/java/org/springframework/batch/core/scope/util

cp -p src/assembly/license.txt .
cp -p src/assembly/notice.txt .

sed -i 's/\r//' license.txt notice.txt

%pom_remove_plugin :maven-assembly-plugin
%pom_remove_plugin com.agilejava.docbkx:docbkx-maven-plugin
%pom_remove_plugin org.codehaus.mojo:jdepend-maven-plugin
%pom_remove_plugin com.springsource.bundlor:com.springsource.bundlor.maven
%pom_remove_plugin com.springsource.bundlor:com.springsource.bundlor.maven spring-batch-parent
# require com.springsource.bundlor:com.springsource.bundlor.maven
%pom_remove_plugin org.eclipse.m2e:lifecycle-mapping spring-batch-parent
# require foundrylogic.vpp vpp 2.2.1
%pom_remove_plugin org.apache.maven.plugins:maven-antrun-plugin spring-batch-parent
# org.springframework.build.aws org.springframework.build.aws.maven
%pom_xpath_remove pom:build/pom:extensions
%pom_xpath_remove pom:build/pom:extensions spring-batch-parent

%pom_xpath_remove "pom:build/pom:pluginManagement/pom:plugins/pom:plugin[pom:artifactId = 'maven-antrun-plugin']/pom:dependencies/pom:dependency[pom:groupId = 'org.springframework.build']"

sed -i 's|${pom.version}|${project.version}|' pom.xml spring-batch-parent/pom.xml spring-batch-core/pom.xml

# hibernate-annotations apis are available in hibernate-core
%pom_remove_dep org.hibernate:hibernate-annotations spring-batch-infrastructure
%pom_remove_dep org.hibernate:hibernate-annotations spring-batch-infrastructure-tests
%pom_remove_dep org.hibernate:hibernate-annotations spring-batch-parent
%pom_remove_dep org.hibernate:hibernate-annotations spring-batch-samples

# Fix hibernate3 version
%pom_xpath_set "pom:dependencyManagement/pom:dependencies/pom:dependency[pom:groupId = 'org.hibernate']/pom:version" 3 spring-batch-parent
for p in spring-batch-infrastructure \
 spring-batch-infrastructure-tests \
 spring-batch-samples;do
%pom_xpath_inject "pom:dependencies/pom:dependency[pom:groupId = 'org.hibernate']" "<version>3</version>" ${p}
done

# Fix for hsqldb
for p in spring-batch-core \
 spring-batch-core-tests \
 spring-batch-infrastructure-tests \
 spring-batch-samples \
 spring-batch-test;do
%pom_xpath_inject "pom:dependencies/pom:dependency[pom:artifactId = 'hsqldb']" "<version>1</version>" ${p}
done

# Fix cglib aId
%pom_xpath_set "pom:dependencyManagement/pom:dependencies/pom:dependency[pom:groupId = 'cglib']/pom:artifactId" cglib spring-batch-parent

for p in spring-batch-core-tests \
 spring-batch-infrastructure \
 spring-batch-samples;do
%pom_xpath_set "pom:dependencies/pom:dependency[pom:groupId = 'cglib']/pom:artifactId" cglib ${p}
done

# Force use of springframework-ws
sed -i "s|<spring.oxm.artifact>spring-oxm-tiger|<spring.oxm.artifact>spring-ws-core|" spring-batch-parent/pom.xml

%pom_xpath_inject pom:properties '
  <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
  <project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>' spring-batch-parent

%pom_xpath_remove "pom:dependencies/pom:dependency[pom:scope = 'test']" spring-batch-parent
%pom_xpath_remove "pom:dependencies/pom:dependency[pom:scope = 'test']" spring-batch-core
%pom_xpath_remove "pom:dependencies/pom:dependency[pom:scope = 'test']" spring-batch-infrastructure

# unavailable deps. require: 2.3.4.726 < ibatis-sqlmap > 2.3.0
%pom_remove_dep org.apache.ibatis:ibatis-sqlmap spring-batch-infrastructure
rm -r spring-batch-infrastructure/src/main/java/org/springframework/batch/item/database/Ibatis*.java \
  spring-batch-infrastructure/src/test/java/org/springframework/batch/item/database/Ibatis*.java

%pom_remove_dep org.springframework:spring-test spring-batch-infrastructure

# require foundrylogic.vpp vpp 2.2.1 for generate sql resources
%if %with_vpp
%pom_xpath_inject "pom:build/pom:plugins/pom:plugin[pom:artifactId = 'maven-antrun-plugin']" \
"<dependencies>
  <dependency>
    <groupId>foundrylogic.vpp</groupId>
    <artifactId>vpp</artifactId>
    <version>2.2.1</version>
  </dependency>
</dependencies>" spring-batch-core
# regenerate resources.
rm -r spring-batch-core/src/main/resources/org/springframework/batch/core/*.sql
# Fix resources location
sed -i 's|${basedir}/target/generated-resources|${basedir}/target/generated-resources/org/springframework/batch/core|' spring-batch-core/pom.xml
%pom_xpath_inject "pom:project/pom:build" '
<resources>
  <resource>
    <directory>${basedir}/src/main/resources</directory>
    <includes>
      <include>**/*</include>
    </includes>
  </resource>
  <resource>
    <directory>${basedir}/target/generated-resources</directory>
    <includes>
      <include>**/*</include>
    </includes>
  </resource>
</resources>' spring-batch-core
%else
%pom_remove_plugin org.apache.maven.plugins:maven-antrun-plugin spring-batch-core
%endif

# Fix org.osgi.core gId aId
%pom_xpath_set "pom:dependencies/pom:dependency[pom:groupId = 'org.osgi']/pom:groupId" org.apache.felix spring-batch-core
%pom_xpath_set "pom:dependencies/pom:dependency[pom:artifactId = 'osgi_R4_core']/pom:artifactId" org.osgi.core spring-batch-core

# Use newer org.springframework.osgi
%pom_xpath_set "pom:dependencies/pom:dependency[pom:groupId = 'org.springframework.osgi']/pom:groupId" org.eclipse.gemini.blueprint spring-batch-core
%pom_xpath_set "pom:dependencies/pom:dependency[pom:artifactId = 'spring-osgi-core']/pom:artifactId" gemini-blueprint-core spring-batch-core
sed -i "s|org.springframework.osgi|org.eclipse.gemini.blueprint|" spring-batch-core/src/main/java/org/springframework/batch/core/configuration/support/OsgiBundleXmlApplicationContextFactory.java

%pom_remove_dep org.aspectj:aspectjrt spring-batch-core

%pom_remove_dep org.springframework:spring-test spring-batch-test
rm -r spring-batch-test/src/main/java/org/springframework/batch/test/StepScopeTestExecutionListener.java

%pom_xpath_set "pom:dependencies/pom:dependency[pom:groupId = 'org.aspectj']/pom:artifactId" aspectjweaver  spring-batch-test

# add OSGi support and FIX Bundle-SymbolicName
%pom_add_plugin org.apache.felix:maven-bundle-plugin spring-batch-infrastructure '
<extensions>true</extensions>
<configuration>
  <instructions>
    <Bundle-SymbolicName>org.springframework.batch.infrastructure</Bundle-SymbolicName>
    <Bundle-Name>Spring Batch Infrastructure</Bundle-Name>
    <Bundle-Vendor>Spring</Bundle-Vendor>
    <Bundle-Version>${project.version}</Bundle-Version>
  </instructions>
</configuration>
<executions>
  <execution>
    <id>bundle-manifest</id>
    <phase>process-classes</phase>
    <goals>
      <goal>manifest</goal>
    </goals>
  </execution>
</executions>'

%pom_add_plugin org.apache.felix:maven-bundle-plugin spring-batch-core '
<extensions>true</extensions>
<configuration>
  <instructions>
    <Bundle-SymbolicName>org.springframework.batch.core</Bundle-SymbolicName>
    <Bundle-Name>Spring Batch Core</Bundle-Name>
    <Bundle-Vendor>Spring</Bundle-Vendor>
    <Bundle-Version>${project.version}</Bundle-Version>
  </instructions>
</configuration>
<executions>
  <execution>
    <id>bundle-manifest</id>
    <phase>process-classes</phase>
    <goals>
      <goal>manifest</goal>
    </goals>
  </execution>
</executions>'

%pom_xpath_inject "pom:build" '
<plugins>
<plugin>
  <groupId>org.apache.felix</groupId>
  <artifactId>maven-bundle-plugin</artifactId>
  <version>any</version>
  <extensions>true</extensions>
  <configuration>
    <instructions>
      <Bundle-SymbolicName>org.springframework.batch.test</Bundle-SymbolicName>
      <Bundle-Name>Spring Batch Test</Bundle-Name>
      <Bundle-Vendor>Spring</Bundle-Vendor>
      <Bundle-Version>${project.version}</Bundle-Version>
    </instructions>
  </configuration>
  <executions>
    <execution>
      <id>bundle-manifest</id>
      <phase>process-classes</phase>
      <goals>
       <goal>manifest</goal>
      </goals>
    </execution>
  </executions>
</plugin>
</plugins>' spring-batch-test

sed -i "s|<version>1.2.14</version>|<version>1.2.17</version>|" spring-batch-parent/pom.xml


%build

# unavailable test deps: org.springframework spring-test
%mvn_build -f

%install
%mvn_install

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc README.md
%license license.txt notice.txt

%files javadoc -f .mfiles-javadoc
%license license.txt notice.txt

%changelog
* Wed Feb 11 2015 gil cattaneo <puntogil@libero.it> 2.1.9-3
- introduce license macro

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.1.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Nov 29 2012 gil cattaneo <puntogil@libero.it> 2.1.9-1
- initial rpm
